paddle_build.sh 72.1 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
#!/usr/bin/env bash

# Copyright (c) 2018 PaddlePaddle Authors. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#=================================================
#                   Utils
#=================================================

21 22
set -ex

Z
Zeng Jinle 已提交
23 24 25 26
if [ -z ${BRANCH} ]; then
    BRANCH="develop"
fi

27 28
function print_usage() {
    echo -e "\n${RED}Usage${NONE}:
29
    ${BOLD}${SCRIPT_NAME}${NONE} [OPTION]"
Q
Qiyang Min 已提交
30

31 32 33
    echo -e "\n${RED}Options${NONE}:
    ${BLUE}build${NONE}: run build for x86 platform
    ${BLUE}test${NONE}: run all unit tests
34
    ${BLUE}single_test${NONE}: run a single unit test
35 36
    ${BLUE}bind_test${NONE}: parallel tests bind to different GPU
    ${BLUE}doc${NONE}: generate paddle documents
37
    ${BLUE}gen_doc_lib${NONE}: generate paddle documents library
38 39 40 41
    ${BLUE}html${NONE}: convert C++ source code into HTML
    ${BLUE}dockerfile${NONE}: generate paddle release dockerfile
    ${BLUE}fluid_inference_lib${NONE}: deploy fluid inference library
    ${BLUE}check_style${NONE}: run code style check
42 43
    ${BLUE}cicheck${NONE}: run CI tasks on Linux
    ${BLUE}maccheck${NONE}: run CI tasks on Mac
44 45 46 47
    "
}

function init() {
48 49 50 51 52
    RED='\033[0;31m'
    BLUE='\033[0;34m'
    BOLD='\033[1m'
    NONE='\033[0m'

53
    PADDLE_ROOT="$( cd "$( dirname "${BASH_SOURCE[0]}")/../../" && pwd )"
54 55 56
    if [ -z "${SCRIPT_NAME}" ]; then
        SCRIPT_NAME=$0
    fi
Z
Zeng Jinle 已提交
57 58

    ENABLE_MAKE_CLEAN=${ENABLE_MAKE_CLEAN:-ON}
59 60 61

    # NOTE(chenweihang): For easy debugging, CI displays the C++ error stacktrace by default 
    export FLAGS_call_stack_level=2
62 63
}

64
function cmake_base() {
R
randytli 已提交
65
    # Build script will not fail if *.deb does not exist
66
    rm *.deb 2>/dev/null || true
R
randytli 已提交
67
    # Delete previous built whl packages
68 69 70 71 72
    rm -rf python/dist 2>/dev/null || true

    # Support build for all python versions, currently
    # including cp27-cp27m and cp27-cp27mu.
    PYTHON_FLAGS=""
73
    SYSTEM=`uname -s`
J
Jiabin Yang 已提交
74
    if [ "$SYSTEM" == "Darwin" ]; then
V
velconia 已提交
75
        echo "Using python abi: $1"
J
Jiabin Yang 已提交
76
        if [[ "$1" == "cp27-cp27m" ]] || [[ "$1" == "" ]]; then
77 78 79
            if [ -d "/Library/Frameworks/Python.framework/Versions/2.7" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/2.7
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/2.7
J
Jiabin Yang 已提交
80
                export PATH=/Library/Frameworks/Python.framework/Versions/2.7/bin/:${PATH}
81 82
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/2.7/bin/python2.7
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/2.7/include/python2.7
J
Jiabin Yang 已提交
83
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/2.7/lib/libpython2.7.dylib"
84
                pip install --user -r ${PADDLE_ROOT}/python/requirements.txt
85 86 87
            else
                exit 1
            fi
V
velconia 已提交
88
        elif [ "$1" == "cp35-cp35m" ]; then
V
velconia 已提交
89
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.5" ]; then
V
velconia 已提交
90 91 92 93 94 95
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.5/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.5/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.5/include/python3.5m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/libpython3.5m.dylib"
96
                pip3.5 install --user -r ${PADDLE_ROOT}/python/requirements.txt
V
velconia 已提交
97 98 99
            else
                exit 1
            fi
M
minqiyang 已提交
100 101 102 103 104 105 106 107
        elif [ "$1" == "cp36-cp36m" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.6" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.6/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.6/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.6/include/python3.6m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/libpython3.6m.dylib"
108
                pip3.6 install --user -r ${PADDLE_ROOT}/python/requirements.txt
M
minqiyang 已提交
109 110 111 112 113 114 115 116 117 118 119
            else
                exit 1
            fi
        elif [ "$1" == "cp37-cp37m" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.7" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.7/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.7/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.7/include/python3.7m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/libpython3.7m.dylib"
120
                pip3.7 install --user -r ${PADDLE_ROOT}/python/requirements.txt
M
minqiyang 已提交
121 122 123
            else
                exit 1
            fi
G
guofei 已提交
124 125 126 127 128 129 130 131 132 133 134 135
        elif [ "$1" == "cp38-cp38" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.8" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.8/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.8/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.8/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.8/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.8/include/python3.8/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.8/lib/libpython3.8.dylib"
                pip3.8 install --user -r ${PADDLE_ROOT}/python/requirements.txt
            else
                exit 1
            fi
136
        fi
M
minqiyang 已提交
137
    else
138
        if [ "$1" != "" ]; then
M
minqiyang 已提交
139
            echo "using python abi: $1"
140
            if [ "$1" == "cp27-cp27m" ]; then
T
tianshuo78520a 已提交
141
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs2/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs4/lib:}
142 143 144
                export PATH=/opt/python/cp27-cp27m/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27m/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27m/include/python2.7
T
tianshuo78520a 已提交
145
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs2/lib/libpython2.7.so"
146
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
147
            elif [ "$1" == "cp27-cp27mu" ]; then
T
tianshuo78520a 已提交
148
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs4/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs2/lib:}
149 150 151
                export PATH=/opt/python/cp27-cp27mu/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27mu/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27mu/include/python2.7
T
tianshuo78520a 已提交
152
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs4/lib/libpython2.7.so"
153 154 155 156 157 158 159 160 161 162 163 164 165 166
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
            elif [ "$1" == "cp27-cp27m-gcc82" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs2/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs4/lib:}
                export PATH=/opt/python/cp27-cp27m/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27m/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27m/include/python2.7
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs2/lib/libpython2.7.so"
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
            elif [ "$1" == "cp27-cp27mu-gcc82" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs4/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs2/lib:}
                export PATH=/opt/python/cp27-cp27mu/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27mu/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27mu/include/python2.7
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs4/lib/libpython2.7.so"
167
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
168 169 170 171
            elif [ "$1" == "cp35-cp35m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.5.1/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.5.1/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.5.1/bin/python3
M
minqiyang 已提交
172 173
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.5.1/include/python3.5m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.5.1/lib/libpython3.so"
174
                pip3.5 install -r ${PADDLE_ROOT}/python/requirements.txt
175 176 177 178 179 180
            elif [ "$1" == "cp36-cp36m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.6.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.6.0/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.6.0/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.6.0/include/python3.6m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.6.0/lib/libpython3.so"
181
                pip3.6 install -r ${PADDLE_ROOT}/python/requirements.txt
182 183 184
            elif [ "$1" == "cp37-cp37m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.7.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.7.0/bin/:${PATH}
185
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.7.0/bin/python3.7
186 187
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.7.0/include/python3.7m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.7.0/lib/libpython3.so"
188
                pip3.7 install -r ${PADDLE_ROOT}/python/requirements.txt
G
guofei 已提交
189 190 191 192 193 194 195
            elif [ "$1" == "cp38-cp38" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.8.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.8.0/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.8.0/bin/python3.8
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.8.0/include/python3.8
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.8.0/lib/libpython3.so"
                pip3.8 install -r ${PADDLE_ROOT}/python/requirements.txt
196
           fi
197 198
        else
            pip install -r ${PADDLE_ROOT}/python/requirements.txt
199 200
        fi
    fi
M
minqiyang 已提交
201

J
JiabinYang 已提交
202
    if [ "$SYSTEM" == "Darwin" ]; then
203 204
        WITH_DISTRIBUTE=${WITH_DISTRIBUTE:-ON}
        WITH_AVX=${WITH_AVX:-ON}
J
Jiabin Yang 已提交
205
        INFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR:-~/.cache/inference_demo}
J
JiabinYang 已提交
206
    else
J
Jiabin Yang 已提交
207
        INFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR:-/root/.cache/inference_demo}
208
    fi
M
minqiyang 已提交
209

G
gongweibao 已提交
210 211 212
    distibuted_flag=${WITH_DISTRIBUTE:-OFF}
    grpc_flag=${WITH_GRPC:-${distibuted_flag}}

213 214 215 216 217 218
    if [ "$SYSTEM" == "Darwin" ]; then
        gloo_flag="OFF"
    else
        gloo_flag=${distibuted_flag}
    fi

219 220 221 222 223 224
    cat <<EOF
    ========================================
    Configuring cmake in /paddle/build ...
        -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE:-Release}
        ${PYTHON_FLAGS}
        -DWITH_GPU=${WITH_GPU:-OFF}
225
        -DWITH_TENSORRT=${WITH_TENSORRT:-ON}
226
        -DWITH_AMD_GPU=${WITH_AMD_GPU:-OFF}
G
gongweibao 已提交
227
        -DWITH_DISTRIBUTE=${distibuted_flag}
228 229 230 231 232 233
        -DWITH_MKL=${WITH_MKL:-ON}
        -DWITH_AVX=${WITH_AVX:-OFF}
        -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-All}
        -DWITH_PYTHON=${WITH_PYTHON:-ON}
        -DCUDNN_ROOT=/usr/
        -DWITH_TESTING=${WITH_TESTING:-ON}
234
        -DWITH_COVERAGE=${WITH_COVERAGE:-OFF}
235
        -WITH_INCREMENTAL_COVERAGE=${WITH_INCREMENTAL_COVERAGE:-OFF}
236 237 238 239 240
        -DCMAKE_MODULE_PATH=/opt/rocm/hip/cmake
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
        -DWITH_CONTRIB=${WITH_CONTRIB:-ON}
        -DWITH_INFERENCE_API_TEST=${WITH_INFERENCE_API_TEST:-ON}
241
        -DINFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR}
242
        -DPY_VERSION=${PY_VERSION:-2.7}
W
Wu Yi 已提交
243
        -DCMAKE_INSTALL_PREFIX=${INSTALL_PREFIX:-/paddle/build}
G
gongweibao 已提交
244
        -DWITH_GRPC=${grpc_flag}
245
	    -DWITH_GLOO=${gloo_flag}
石晓伟 已提交
246
        -DWITH_LITE=${WITH_LITE:-OFF}
T
tianshuo78520a 已提交
247
        -DWITH_XPU=${WITH_XPU:-OFF}
248
        -DLITE_GIT_TAG=develop
249
        -DWITH_UNITY_BUILD=${WITH_UNITY_BUILD:-OFF}
250
    ========================================
251
EOF
252 253 254
    # Disable UNITTEST_USE_VIRTUALENV in docker because
    # docker environment is fully controlled by this script.
    # See /Paddle/CMakeLists.txt, UNITTEST_USE_VIRTUALENV option.
Z
zhangchunle 已提交
255
    set +e
256 257 258 259
    cmake .. \
        -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE:-Release} \
        ${PYTHON_FLAGS} \
        -DWITH_GPU=${WITH_GPU:-OFF} \
260
        -DWITH_TENSORRT=${WITH_TENSORRT:-ON} \
261
        -DWITH_AMD_GPU=${WITH_AMD_GPU:-OFF} \
G
gongweibao 已提交
262
        -DWITH_DISTRIBUTE=${distibuted_flag} \
263 264
        -DWITH_MKL=${WITH_MKL:-ON} \
        -DWITH_AVX=${WITH_AVX:-OFF} \
265
        -DNOAVX_CORE_FILE=${NOAVX_CORE_FILE:-""} \
266 267 268 269
        -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-All} \
        -DWITH_PYTHON=${WITH_PYTHON:-ON} \
        -DCUDNN_ROOT=/usr/ \
        -DWITH_TESTING=${WITH_TESTING:-ON} \
270
        -DWITH_COVERAGE=${WITH_COVERAGE:-OFF} \
271
        -WITH_INCREMENTAL_COVERAGE=${WITH_INCREMENTAL_COVERAGE:-OFF} \
272 273 274 275
        -DCMAKE_MODULE_PATH=/opt/rocm/hip/cmake \
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON \
        -DWITH_CONTRIB=${WITH_CONTRIB:-ON} \
        -DWITH_INFERENCE_API_TEST=${WITH_INFERENCE_API_TEST:-ON} \
Z
zhangchunle 已提交
276
        -DINFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR} \
W
Wu Yi 已提交
277
        -DPY_VERSION=${PY_VERSION:-2.7} \
M
minqiyang 已提交
278
        -DCMAKE_INSTALL_PREFIX=${INSTALL_PREFIX:-/paddle/build} \
石晓伟 已提交
279
        -DWITH_GRPC=${grpc_flag} \
280
	    -DWITH_GLOO=${gloo_flag} \
281
        -DLITE_GIT_TAG=develop \
T
tianshuo78520a 已提交
282
        -DWITH_XPU=${WITH_XPU:-OFF} \
283 284
        -DWITH_LITE=${WITH_LITE:-OFF} \
        -DWITH_UNITY_BUILD=${WITH_UNITY_BUILD:-OFF};build_error=$?
Z
zhangchunle 已提交
285 286 287
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
288 289
}

290 291 292 293 294 295
function cmake_gen() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cmake_base $1
}

C
chalsliu 已提交
296 297 298 299
function cmake_gen_in_current_dir() {
    cmake_base $1
}

300 301 302
function abort(){
    echo "Your change doesn't follow PaddlePaddle's code style." 1>&2
    echo "Please use pre-commit to check what is wrong." 1>&2
303
    exit 4
304 305 306 307 308 309
}

function check_style() {
    trap 'abort' 0
    set -e

310 311 312
    if [ -x "$(command -v gimme)" ]; then
    	eval "$(GIMME_GO_VERSION=1.8.3 gimme)"
    fi
313

314 315

    pip install cpplint pylint pytest astroid isort
316 317 318 319 320 321 322
    # set up go environment for running gometalinter
    mkdir -p $GOPATH/src/github.com/PaddlePaddle/
    ln -sf ${PADDLE_ROOT} $GOPATH/src/github.com/PaddlePaddle/Paddle

    pre-commit install
    clang-format --version

T
tianshuo78520a 已提交
323
    commit_files=on
324 325
    for file_name in `git diff --numstat upstream/$BRANCH |awk '{print $NF}'`;do
        if ! pre-commit run --files $file_name ; then
T
tianshuo78520a 已提交
326
            commit_files=off
327 328
        fi
    done 
T
tianshuo78520a 已提交
329 330 331
    
    if [ $commit_files == 'off' ];then
        echo "code format error"
332
        git diff 2>&1
333
        exit 4
T
tianshuo78520a 已提交
334
    fi
335 336 337 338 339 340 341
    trap : 0
}

#=================================================
#              Build
#=================================================

342
function build_base() {
Z
zhangchunle 已提交
343
    set +e
344
    if [ "$SYSTEM" == "Linux" ];then
345
      if [ `nproc` -gt 16 ];then
346
          parallel_number=$(expr `nproc` - 8)
347 348 349
      else
          parallel_number=`nproc`
      fi
350 351 352 353
    else
      parallel_number=8
    fi
    if [ "$1" != "" ]; then
354 355
      parallel_number=$1
    fi
Z
Zeng Jinle 已提交
356 357 358 359 360

    if [[ "$ENABLE_MAKE_CLEAN" != "OFF" ]]; then
        make clean
    fi

Z
zhangchunle 已提交
361 362 363 364
    make install -j ${parallel_number};build_error=$?
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
365 366
}

Z
zhangchunle 已提交
367 368 369 370 371 372
function build_size() {
    cat <<EOF
    ============================================
    Calculate /paddle/build size and PR whl size
    ============================================
EOF
373
    if [ "$1" == "paddle_inference" ]; then
Z
zhangchunle 已提交
374
        cd ${PADDLE_ROOT}/build
375 376 377 378
        cp -r paddle_inference_install_dir paddle_inference
        tar -czf paddle_inference.tgz paddle_inference
        buildSize=$(du -h --max-depth=0 ${PADDLE_ROOT}/build/paddle_inference.tgz |awk '{print $1}')
        echo "Paddle_Inference Size: $buildSize"
Z
zhangchunle 已提交
379 380 381 382 383 384 385 386 387 388 389 390 391 392
    else
        SYSTEM=`uname -s`
        if [ "$SYSTEM" == "Darwin" ]; then
            com='du -h -d 0'
        else
            com='du -h --max-depth=0'
        fi
        buildSize=$($com ${PADDLE_ROOT}/build |awk '{print $1}')
        echo "Build Size: $buildSize"
        PR_whlSize=$($com ${PADDLE_ROOT}/build/python/dist |awk '{print $1}')
        echo "PR whl Size: $PR_whlSize"
    fi
}

393 394 395 396 397 398 399 400
function build() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ============================================
    Building in /paddle/build ...
    ============================================
EOF
Z
Zeng Jinle 已提交
401
    build_base $@
Z
zhangchunle 已提交
402 403 404 405 406 407 408 409 410 411 412 413
    current_branch=`git branch | grep \* | cut -d ' ' -f2`
    if [ "$current_branch" != "develop_base_pr" ];then
        build_size
    fi
}

function cmake_gen_and_build() {
    startTime_s=`date +%s`
    cmake_gen $1
    build $2
    endTime_s=`date +%s`
    echo "Build Time: $[ $endTime_s - $startTime_s ]s"
414 415
}

416
function build_mac() {
Z
zhangchunle 已提交
417
    set +e
418 419 420 421 422 423 424
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ============================================
    Building in /paddle/build ...
    ============================================
EOF
Z
Zeng Jinle 已提交
425 426 427
    if [[ "$ENABLE_MAKE_CLEAN" != "OFF" ]]; then
        make clean
    fi
Z
zhangchunle 已提交
428 429 430 431 432
    make install -j 8;build_error=$?
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
    set -e
Z
zhangchunle 已提交
433 434 435 436 437 438 439 440 441
    build_size
}

function cmake_gen_and_build_mac() {
    startTime_s=`date +%s`
    cmake_gen $1
    build_mac
    endTime_s=`date +%s`
    echo "Build Time: $[ $endTime_s - $startTime_s ]s"
442 443
}

444 445 446 447 448 449 450 451 452
function run_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit tests ...
    ========================================
EOF
453 454 455 456 457
        if [ ${TESTING_DEBUG_MODE:-OFF} == "ON" ] ; then
            ctest -V
        else
            ctest --output-on-failure
        fi
458 459 460
    fi
}

461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479

function combine_avx_noavx_build() {
    mkdir -p ${PADDLE_ROOT}/build.noavx
    cd ${PADDLE_ROOT}/build.noavx
    WITH_AVX=OFF
    cmake_base ${PYTHON_ABI:-""}
    build_base

    # build combined one
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    NOAVX_CORE_FILE=`find ${PADDLE_ROOT}/build.noavx/python/paddle/fluid/ -name "core_noavx.*"`
    WITH_AVX=ON

    cmake_base ${PYTHON_ABI:-""}
    build_base
}


G
gongweibao 已提交
480 481 482 483 484 485 486 487 488 489 490 491
function run_brpc_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [[ ${WITH_TESTING:-ON} == "ON" \
        && ${WITH_DISTRIBUTE:-OFF} == "ON" \
        && ${WITH_GRPC:-OFF} == "OFF" ]] ; then
    cat <<EOF
    ========================================
    Running brpc unit tests ...
    ========================================
EOF
        set +x
492 493
        declare -a other_tests=("test_listen_and_serv_op" "system_allocator_test" \
        "rpc_server_test" "varhandle_test" "collective_server_test" "brpc_serde_test")
G
gongweibao 已提交
494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519
        all_tests=`ctest -N`

        for t in "${other_tests[@]}"
        do
            if [[ ${all_tests} != *$t* ]]; then
                continue
            fi

            if [[ ${TESTING_DEBUG_MODE:-OFF} == "ON" ]] ; then
                ctest -V -R $t
            else
                ctest --output-on-failure -R $t
            fi
        done
        set -x

        if [[ ${TESTING_DEBUG_MODE:-OFF} == "ON" ]] ; then
            ctest -V -R test_dist_*
        else
            ctest --output-on-failure -R test_dist_*
        fi
    fi
}



520 521 522 523 524 525 526 527 528
function run_mac_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit tests ...
    ========================================
EOF
529 530
        #remove proxy here to fix dist ut 'test_fl_listen_and_serv_op' error on mac. 
        #see details: https://github.com/PaddlePaddle/Paddle/issues/24738
T
tianshuo78520a 已提交
531
        set +x
532
        my_proxy=$http_proxy
J
JiabinYang 已提交
533 534
        export http_proxy=
        export https_proxy=
T
tianshuo78520a 已提交
535
        set -x
536 537 538 539 540 541 542 543 544 545

        set +ex
        if [ "$1" == "cp27-cp27m" ]; then
            pip uninstall -y paddlepaddle
        elif [ "$1" == "cp35-cp35m" ]; then
            pip3.5 uninstall -y paddlepaddle
        elif [ "$1" == "cp36-cp36m" ]; then
            pip3.6 uninstall -y paddlepaddle
        elif [ "$1" == "cp37-cp37m" ]; then
            pip3.7 uninstall -y paddlepaddle
G
guofei 已提交
546 547
        elif [ "$1" == "cp38-cp38" ]; then
            pip3.8 uninstall -y paddlepaddle
548 549 550
        fi
        set -ex

551
        if [ "$1" == "cp27-cp27m" ]; then
552
            set -e
553
            pip install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
J
JiabinYang 已提交
554
            python ${PADDLE_ROOT}/paddle/scripts/installation_validate.py
555 556 557 558 559 560
        elif [ "$1" == "cp35-cp35m" ]; then
            pip3.5 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
        elif [ "$1" == "cp36-cp36m" ]; then
            pip3.6 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
        elif [ "$1" == "cp37-cp37m" ]; then
            pip3.7 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
G
guofei 已提交
561 562
        elif [ "$1" == "cp38-cp38" ]; then
            pip3.8 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
563
        fi
564 565
        tmpfile_rand=`date +%s%N`
        tmpfile=$tmp_dir/$tmpfile_rand
Y
YUNSHEN XIE 已提交
566
        set +ex
Z
zhangchunle 已提交
567
        ut_startTime_s=`date +%s`
Y
YUNSHEN XIE 已提交
568
        get_quickly_disable_ut||disable_ut_quickly='' # indicate whether the case was in quickly disable list 
569 570 571
        if [ ${NIGHTLY_MODE:-OFF} == "ON" ]; then
            nightly_label=""
        else
572
            nightly_label="(RUN_TYPE=NIGHTLY|RUN_TYPE=DIST:NIGHTLY|RUN_TYPE=EXCLUSIVE:NIGHTLY)"
573 574 575 576
            echo "========================================="
            echo "Unittests with nightly labels  are only run at night"
            echo "========================================="
        fi
577
        ctest -E "($disable_ut_quickly)" -LE ${nightly_label} --output-on-failure -j $2 | tee $tmpfile
578 579 580 581 582 583 584
        failed_test_lists=''
        collect_failed_tests
        mactest_error=0
        retry_unittests_record=''
        retry_time=3
        exec_times=0
        exec_time_array=('first' 'second' 'third')
585
        exec_retry_threshold=20
586 587
        if [ -n "$failed_test_lists" ];then
            mactest_error=1
588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624
            read need_retry_ut_str <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(" | sed 's/(//' | sed 's/- //' )
            need_retry_ut_arr=(${need_retry_ut_str})
            need_retry_ut_count=${#need_retry_ut_arr[@]}
            if [ $need_retry_ut_count -lt $exec_retry_threshold ];then
                while ( [ $exec_times -lt $retry_time ] && [ -n "${failed_test_lists}" ] )
                    do
                        retry_unittests_record="$retry_unittests_record$failed_test_lists"
                        failed_test_lists_ult=`echo "${failed_test_lists}"`
                        read retry_unittests <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(" | sed 's/(//' | sed 's/- //' )
                        echo "========================================="
                        echo "This is the ${exec_time_array[$exec_times]} time to re-run"
                        echo "========================================="
                        echo "The following unittest will be re-run:"
                        echo "${retry_unittests}"
                        echo "========================================="

                        retry_unittests_regular=''
                        for line in ${retry_unittests[@]} ;
                            do
                                if [[ "$retry_unittests_regular" == "" ]];then
                                    retry_unittests_regular="^$line$"
                                else
                                    retry_unittests_regular="$retry_unittests_regular|^$line$"
                                fi
                            done
                        rm -f $tmp_dir/*
                        failed_test_lists=''
                        ctest -R "($retry_unittests_regular)" --output-on-failure -j $2 | tee $tmpfile
                        collect_failed_tests
                        exec_times=$[$exec_times+1]
                    done
            else
                echo "========================================="
                echo "There are more than 20 failed unit tests, so no unit test retry!!!"
                echo "========================================="
            fi

625 626
        fi
        #mactest_error=$?
Z
zhangchunle 已提交
627 628
        ut_endTime_s=`date +%s`
        echo "Mac testCase Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
T
Tao Luo 已提交
629
        paddle version
630
        # Recovery proxy to avoid failure in later steps
T
tianshuo78520a 已提交
631
        set +x
632 633
        export http_proxy=$my_proxy
        export https_proxy=$my_proxy
T
tianshuo78520a 已提交
634
        set -x
635
        if [ "$mactest_error" != 0 ];then
636 637 638 639 640 641 642 643 644 645 646 647 648 649 650
            if [[ "$failed_test_lists" == "" ]]; then
                echo "========================================"
                echo "There are failed tests, which have been successful after re-run:"
                echo "========================================"
                echo "The following tests have been re-ran:"
                echo "${retry_unittests_record}"
            else
                failed_test_lists_ult=`echo "${failed_test_lists}"`
                echo "========================================"
                echo "Summary Failed Tests... "
                echo "========================================"
                echo "The following tests FAILED: "
                echo "${failed_test_lists_ult}"
                exit 8;
            fi
651
        fi
652 653 654
    fi
}

Z
Zeng Jinle 已提交
655 656 657 658 659 660 661 662 663 664 665 666 667 668
function fetch_upstream_develop_if_not_exist() {
    UPSTREAM_URL='https://github.com/PaddlePaddle/Paddle'
    origin_upstream_url=`git remote -v | awk '{print $1, $2}' | uniq | grep upstream | awk '{print $2}'` 
    if [ "$origin_upstream_url" == "" ]; then
        git remote add upstream $UPSTREAM_URL.git
    elif [ "$origin_upstream_url" != "$UPSTREAM_URL" ] \
            && [ "$origin_upstream_url" != "$UPSTREAM_URL.git" ]; then
        git remote remove upstream
        git remote add upstream $UPSTREAM_URL.git
    fi
    
    if [ ! -e "$PADDLE_ROOT/.git/refs/remotes/upstream/$BRANCH" ]; then 
        git fetch upstream # develop is not fetched
    fi
Z
Zeng Jinle 已提交
669
}
Z
Zeng Jinle 已提交
670 671 672

function generate_upstream_develop_api_spec() {
    fetch_upstream_develop_if_not_exist
Z
Zeng Jinle 已提交
673
    cur_branch=`git branch | grep \* | cut -d ' ' -f2`
674
    git checkout .
Z
Zeng Jinle 已提交
675 676 677
    git checkout -b develop_base_pr upstream/$BRANCH
    cmake_gen $1
    build $2
678
    cp ${PADDLE_ROOT}/python/requirements.txt /tmp
Z
Zeng Jinle 已提交
679

Z
Zeng Jinle 已提交
680
    git checkout $cur_branch
Z
Zeng Jinle 已提交
681
    generate_api_spec "$1" "DEV"
682
    git branch -D develop_base_pr
683 684
    ENABLE_MAKE_CLEAN="ON"
    rm -rf ${PADDLE_ROOT}/build/Makefile ${PADDLE_ROOT}/build/CMakeCache.txt
Z
Zeng Jinle 已提交
685 686 687
}

function generate_api_spec() {
T
tianshuo78520a 已提交
688
    set -e
Z
Zeng Jinle 已提交
689 690 691 692 693 694
    spec_kind=$2
    if [ "$spec_kind" != "PR" ] && [ "$spec_kind" != "DEV" ]; then
        echo "Not supported $2"
        exit 1
    fi

Y
yuyang18 已提交
695 696
    mkdir -p ${PADDLE_ROOT}/build/.check_api_workspace
    cd ${PADDLE_ROOT}/build/.check_api_workspace
Z
Zeng Jinle 已提交
697 698
    virtualenv .${spec_kind}_env
    source .${spec_kind}_env/bin/activate
699 700 701 702 703 704

    if [ "$spec_kind" == "DEV" ]; then
        pip install -r /tmp/requirements.txt
    else
        pip install -r ${PADDLE_ROOT}/python/requirements.txt
    fi
T
Tao Luo 已提交
705
    pip --no-cache-dir install ${PADDLE_ROOT}/build/python/dist/*whl
706
    spec_path=${PADDLE_ROOT}/paddle/fluid/API_${spec_kind}.spec
Z
Zeng Jinle 已提交
707
    python ${PADDLE_ROOT}/tools/print_signatures.py paddle > $spec_path
708

709 710 711
    # used to log op_register data_type
    op_type_path=${PADDLE_ROOT}/paddle/fluid/OP_TYPE_${spec_kind}.spec
    python ${PADDLE_ROOT}/tools/check_op_register_type.py > $op_type_path
712 713 714 715 716

    # print all ops desc in dict to op_desc_path
    op_desc_path=${PADDLE_ROOT}/paddle/fluid/OP_DESC_${spec_kind}.spec
    python ${PADDLE_ROOT}/tools/print_op_desc.py > $op_desc_path

717 718 719 720
    # print api and the md5 of source code of the api.
    api_source_md5_path=${PADDLE_ROOT}/paddle/fluid/API_${spec_kind}.source.md5
    python ${PADDLE_ROOT}/tools/count_api_without_core_ops.py -p paddle > $api_source_md5_path

T
tianshuo78520a 已提交
721 722
    awk -F '(' '{print $NF}' $spec_path >${spec_path}.doc
    awk -F '(' '{$NF="";print $0}' $spec_path >${spec_path}.api
G
guofei 已提交
723
    if [ "$1" == "cp35-cp35m" ] || [ "$1" == "cp36-cp36m" ] || [ "$1" == "cp37-cp37m" ] || [ "$1" == "cp38-cp38" ]; then
M
minqiyang 已提交
724
        # Use sed to make python2 and python3 sepc keeps the same
Z
Zeng Jinle 已提交
725 726 727
        sed -i 's/arg0: str/arg0: unicode/g' $spec_path
        sed -i "s/\(.*Transpiler.*\).__init__ (ArgSpec(args=\['self'].*/\1.__init__ /g" $spec_path
    fi   
Z
Zeng Jinle 已提交
728 729 730
    
    python ${PADDLE_ROOT}/tools/diff_use_default_grad_op_maker.py \
        ${PADDLE_ROOT}/paddle/fluid/op_use_default_grad_maker_${spec_kind}.spec
S
sneaxiy 已提交
731

Y
yuyang18 已提交
732
    deactivate
733 734
}

735
function check_approvals_of_unittest() {
I
iducn 已提交
736
    set +x
737 738 739
    if [ "$GITHUB_API_TOKEN" == "" ] || [ "$GIT_PR_ID" == "" ]; then
        return 0
    fi
740 741
    # approval_user_list: XiaoguangHu01 46782768,luotao1 6836917,phlrain 43953930,lanxianghit 47554610, zhouwei25 52485244, kolinwei 22165420
    check_times=$1
742 743
    if [ $check_times == 1 ]; then
        approval_line=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000`
744
        if [ "${approval_line}" != "" ]; then
745
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 22165420 52485244`
746 747 748 749 750 751 752
            echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
            if [ "${APPROVALS}" == "TRUE" ]; then
                echo "==================================="
                echo -e "\n current pr ${GIT_PR_ID} has got approvals. So, Pass CI directly!\n"
                echo "==================================="
                exit 0
            fi
753
        fi
754
    elif [ $check_times == 2 ]; then
755 756
        unittest_spec_diff=`python ${PADDLE_ROOT}/tools/diff_unittest.py ${PADDLE_ROOT}/paddle/fluid/UNITTEST_DEV.spec ${PADDLE_ROOT}/paddle/fluid/UNITTEST_PR.spec`
        if [ "$unittest_spec_diff" != "" ]; then
757
            approval_line=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000`
758
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 22165420 52485244 32428676 45041955`
759 760 761 762 763
            echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
            if [ "${APPROVALS}" == "FALSE" ]; then
                echo "************************************"
                echo -e "It is forbidden to disable or delete the unit-test.\n"
                echo -e "If you must delete it temporarily, please add it to[https://github.com/PaddlePaddle/Paddle/wiki/Temporarily-disabled-Unit-Test]."
764
                echo -e "Then you must have one RD (kolinwei(recommended), chalsliu, XieYunshen or zhouwei25) approval for the deletion of unit-test. \n"
765 766 767 768 769
                echo -e "If you have any problems about deleting unit-test, please read the specification [https://github.com/PaddlePaddle/Paddle/wiki/Deleting-unit-test-is-forbidden]. \n"
                echo -e "Following unit-tests are deleted in this PR: \n ${unittest_spec_diff} \n"
                echo "************************************"
                exit 1
            fi
770 771
        fi
    fi
772
    set -x
773 774
}

775 776 777 778 779 780 781 782 783 784
function check_diff_file_for_coverage() {
    diff_h_file=$(git diff --name-status test develop | awk '$1 != "D" {print $2}' | grep '\.h$' | awk -F "/" '{printf "%s,",$NF}')
    diff_cc_file=$(git diff --name-status test develop | awk '$1 != "D" {print $2}' | grep -E '\.(cc|c)$' | awk -F "/" '{printf "%s,",$NF}')
    diff_py_file=$(git diff --name-status test develop | grep '\.py$' | awk '$1 != "D" {printf "%s,",$2}')

    export PADDLE_GIT_DIFF_H_FILE=${diff_h_file%*,}
    export PADDLE_GIT_DIFF_CC_FILE=${diff_cc_file%*,}
    export PADDLE_GIT_DIFF_PY_FILE=${diff_py_file%*,}
}

785 786 787 788 789 790 791
function check_change_of_unittest() {
    generate_unittest_spec "PR"
    fetch_upstream_develop_if_not_exist
    git reset --hard upstream/$BRANCH
    cmake_gen $1
    generate_unittest_spec "DEV"
    check_approvals_of_unittest 2
792 793
}

794 795 796 797
function check_sequence_op_unittest(){
    /bin/bash ${PADDLE_ROOT}/tools/check_sequence_op.sh
}

798 799 800 801
function generate_unittest_spec() {
    spec_kind=$1
    if [ "$spec_kind" == "DEV" ]; then
        cat <<EOF
802 803 804
        ============================================
        Generate unit tests.spec of develop.
        ============================================
805 806 807
EOF
    elif [ "$spec_kind" == "PR" ]; then
        cat <<EOF
808 809 810
        ============================================
        Generate unit tests.spec of this PR.
        ============================================
811 812 813 814 815
EOF
    else
        echo "Not supported $1"
        exit 1
    fi
816
    spec_path=${PADDLE_ROOT}/paddle/fluid/UNITTEST_${spec_kind}.spec
817 818 819
    ctest -N | awk -F ':' '{print $2}' | sed '/^$/d' | sed '$d' > ${spec_path}
}

Z
Zeng Jinle 已提交
820

821
function assert_api_spec_approvals() {
Z
zhangchunle 已提交
822 823 824
    /bin/bash ${PADDLE_ROOT}/tools/check_api_approvals.sh;approval_error=$?
    if [ "$approval_error" != 0 ];then
       exit 6
825
    fi
Y
yuyang18 已提交
826 827
}

Z
zhangchunle 已提交
828 829 830 831 832 833 834
function assert_file_diff_approvals() {
    /bin/bash ${PADDLE_ROOT}/tools/check_file_diff_approvals.sh;file_approval_error=$?
    if [ "$file_approval_error" != 0 ];then
       exit 6
    fi
}

Y
yuyang18 已提交
835

L
Liu Xudong 已提交
836 837 838 839 840
function check_coverage() {
    /bin/bash ${PADDLE_ROOT}/tools/coverage/paddle_coverage.sh
}


841 842 843 844 845 846 847 848 849 850 851 852 853 854 855 856 857 858 859
function single_test() {
    TEST_NAME=$1
    if [ -z "${TEST_NAME}" ]; then
        echo -e "${RED}Usage:${NONE}"
        echo -e "${BOLD}${SCRIPT_NAME}${NONE} ${BLUE}single_test${NONE} [test_name]"
        exit 1
    fi
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running ${TEST_NAME} ...
    ========================================
EOF
        ctest --output-on-failure -R ${TEST_NAME}
    fi
}

860 861 862
function bind_test() {
    # the number of process to run tests
    NUM_PROC=6
Q
Qiyang Min 已提交
863

864 865 866
    # calculate and set the memory usage for each process
    MEM_USAGE=$(printf "%.2f" `echo "scale=5; 1.0 / $NUM_PROC" | bc`)
    export FLAGS_fraction_of_gpu_memory_to_use=$MEM_USAGE
Q
Qiyang Min 已提交
867

868 869
    # get the CUDA device count
    CUDA_DEVICE_COUNT=$(nvidia-smi -L | wc -l)
Q
Qiyang Min 已提交
870

871 872 873 874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889
    for (( i = 0; i < $NUM_PROC; i++ )); do
        cuda_list=()
        for (( j = 0; j < $CUDA_DEVICE_COUNT; j++ )); do
            s=$[i+j]
            n=$[s%CUDA_DEVICE_COUNT]
            if [ $j -eq 0 ]; then
                cuda_list=("$n")
            else
                cuda_list="$cuda_list,$n"
            fi
        done
        echo $cuda_list
        # CUDA_VISIBLE_DEVICES http://acceleware.com/blog/cudavisibledevices-masking-gpus
        # ctest -I https://cmake.org/cmake/help/v3.0/manual/ctest.1.html?highlight=ctest
        env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC --output-on-failure &
    done
    wait
}

890 891 892 893 894 895 896 897 898 899 900
EXIT_CODE=0;
function caught_error() {
 for job in `jobs -p`; do
        # echo "PID => ${job}"
        if ! wait ${job} ; then
            echo "At least one test failed with exit code => $?" ;
            EXIT_CODE=1;
        fi
    done
}

Z
zhangchunle 已提交
901 902 903 904 905 906 907 908 909 910 911 912 913 914 915
function case_count(){
    cat <<EOF
    ============================================
    Generating TestCases Count ... 
    ============================================
EOF
    testcases=$1
    num=$(echo $testcases|grep -o '\^'|wc -l)
    if [ "$2" == "" ]; then
        echo "exclusive TestCases count is $num"
    else
        echo "$2 card TestCases count is $num"
    fi
}

Z
zhangchunle 已提交
916 917 918 919 920 921 922 923 924 925 926 927 928 929 930 931 932
failed_test_lists=''
tmp_dir=`mktemp -d`

function collect_failed_tests() {
    for file in `ls $tmp_dir`; do
        exit_code=0
        grep -q 'The following tests FAILED:' $tmp_dir/$file||exit_code=$?
        if [ $exit_code -ne 0 ]; then
            failuretest=''
        else
            failuretest=`grep -A 10000 'The following tests FAILED:' $tmp_dir/$file | sed 's/The following tests FAILED://g'|sed '/^$/d'`
            failed_test_lists="${failed_test_lists}
            ${failuretest}"
        fi
    done
}

Y
YUNSHEN XIE 已提交
933 934 935 936 937 938 939 940 941 942 943 944 945
# getting qucik disable ut list 
function get_quickly_disable_ut() {
    python -m pip install requests
    if disable_ut_quickly=$(python ${PADDLE_ROOT}/tools/get_quick_disable_lt.py); then
        echo "========================================="
        echo "The following unittests have been disabled:"
        echo ${disable_ut_quickly}
        echo "========================================="
    else
        disable_ut_quickly=''
    fi
}

946 947
function card_test() {
    set -m
Z
zhangchunle 已提交
948 949
    case_count $1 $2
    ut_startTime_s=`date +%s` 
950
    # get the CUDA device count, XPU device count is one
T
tianshuo78520a 已提交
951
    if [ "${WITH_XPU}" == "ON" ];then
952
        CUDA_DEVICE_COUNT=1
T
tianshuo78520a 已提交
953 954 955
    else
        CUDA_DEVICE_COUNT=$(nvidia-smi -L | wc -l)
    fi
956 957 958 959 960 961 962 963 964 965 966 967 968 969 970 971

    testcases=$1
    if (( $# > 1 )); then
        cardnumber=$2
        if (( $cardnumber > $CUDA_DEVICE_COUNT )); then
            cardnumber=$CUDA_DEVICE_COUNT
        fi
    else
        cardnumber=$CUDA_DEVICE_COUNT
    fi

    if [[ "$testcases" == "" ]]; then
        return 0
    fi

    trap 'caught_error' CHLD
Z
zhangchunle 已提交
972
    tmpfile_rand=`date +%s%N`
973 974 975 976 977 978 979 980 981 982 983 984
    NUM_PROC=$[CUDA_DEVICE_COUNT/$cardnumber]
    for (( i = 0; i < $NUM_PROC; i++ )); do
        # CUDA_VISIBLE_DEVICES http://acceleware.com/blog/cudavisibledevices-masking-gpus
        # ctest -I https://cmake.org/cmake/help/v3.0/manual/ctest.1.html?highlight=ctest
        cuda_list=()
        for (( j = 0; j < cardnumber; j++ )); do
            if [ $j -eq 0 ]; then
                    cuda_list=("$[i*cardnumber]")
                else
                    cuda_list="$cuda_list,$[i*cardnumber+j]"
            fi
        done
Z
zhangchunle 已提交
985
        tmpfile=$tmp_dir/$tmpfile_rand"_"$i
986 987
        if [ ${TESTING_DEBUG_MODE:-OFF} == "ON" ] ; then
            if [[ $cardnumber == $CUDA_DEVICE_COUNT ]]; then
Y
YUNSHEN XIE 已提交
988
                (ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" -V | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
Z
zhangchunle 已提交
989
            else  
Y
YUNSHEN XIE 已提交
990
                (env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" -V | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
991 992 993
            fi
        else
            if [[ $cardnumber == $CUDA_DEVICE_COUNT ]]; then
Y
YUNSHEN XIE 已提交
994
                (ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" --output-on-failure | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
995
            else
Y
YUNSHEN XIE 已提交
996
                (env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" --output-on-failure | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
997 998 999 1000
            fi
        fi
    done
    wait; # wait for all subshells to finish
Z
zhangchunle 已提交
1001 1002 1003 1004 1005 1006
    ut_endTime_s=`date +%s`
    if [ "$2" == "" ]; then
        echo "exclusive TestCases Total Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
    else
        echo "$2 card TestCases Total Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
    fi
1007
    set +m
1008 1009
}

T
tianshuo78520a 已提交
1010
function parallel_test_base_gpu() {
1011 1012 1013
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
1014
    Running unit tests in parallel way ...
1015 1016 1017 1018
    ========================================
EOF

set +x
C
chalsliu 已提交
1019 1020 1021 1022
        precison_cases=""
        if [ ${PRECISION_TEST:-OFF} == "ON" ]; then
            precision_cases=`python $PADDLE_ROOT/tools/get_pr_ut.py`
        fi
1023
        EXIT_CODE=0;
1024 1025 1026 1027 1028 1029
        test_cases=$(ctest -N -V) # get all test cases
        exclusive_tests=''        # cases list which would be run exclusively
        single_card_tests=''      # cases list which would take one graph card
        multiple_card_tests=''    # cases list which would take multiple GPUs, most cases would be two GPUs
        is_exclusive=''           # indicate whether the case is exclusive type
        is_multicard=''           # indicate whether the case is multiple GPUs type
1030
        is_nightly=''             # indicate whether the case will only run at night
Y
YUNSHEN XIE 已提交
1031
        get_quickly_disable_ut||disable_ut_quickly=''    # indicate whether the case was in quickly disable list 
1032 1033 1034 1035 1036 1037 1038 1039
        while read -r line; do
            if [[ "$line" == "" ]]; then
                continue
            fi
                read matchstr <<< $(echo "$line"|grep -oEi 'Test[ \t]+#')
                if [[ "$matchstr" == "" ]]; then
                    # Any test case with LABELS property would be parse here
                    # RUN_TYPE=EXCLUSIVE mean the case would run exclusively
1040
                    # RUN_TYPE=DIST mean the case would take two graph GPUs during runtime
1041
                    # RUN_TYPE=NIGHTLY or RUN_TYPE=DIST:NIGHTLY or RUN_TYPE=EXCLUSIVE:NIGHTLY means the case will ONLY run at night
1042 1043
                    read is_exclusive <<< $(echo "$line"|grep -oEi "RUN_TYPE=EXCLUSIVE")
                    read is_multicard <<< $(echo "$line"|grep -oEi "RUN_TYPE=DIST")
1044
                    read is_nightly <<< $(echo "$line"|grep -oEi "RUN_TYPE=NIGHTLY|RUN_TYPE=DIST:NIGHTLY|RUN_TYPE=EXCLUSIVE:NIGHTLY")
1045 1046 1047 1048
                    continue
                fi
                read testcase <<< $(echo "$line"|grep -oEi "\w+$")

1049 1050 1051 1052
                if [[ "$is_nightly" != "" ]] && [ ${NIGHTLY_MODE:-OFF} == "OFF" ]; then
                    echo $testcase" will only run at night."
                    continue
                fi
C
chalsliu 已提交
1053 1054 1055 1056 1057 1058 1059 1060 1061 1062 1063 1064 1065
                if [ ${PRECISION_TEST:-OFF} == "ON" ] && [[ "$precision_cases" != "" ]]; then
                    will_test="false"
                    for case in $precision_cases; do
                        if [[ $testcase == $case ]]; then
                            will_test="true"
                            break
                        fi
                    done
                    if [[ $will_test == "false" ]]; then
                        echo $testcase" won't run in PRECISION_TEST mode."
                        continue
                    fi
                fi
1066

1067
                if [[ "$is_multicard" == "" ]]; then
1068
                  # trick: treat all test case with prefix "test_dist" as dist case, and would run on 2 GPUs
1069
                  read is_multicard <<< $(echo "$testcase"|grep -oEi "test_dist_")
1070 1071 1072 1073 1074 1075 1076 1077 1078 1079 1080 1081 1082 1083 1084
                fi

                if [[ "$is_exclusive" != "" ]]; then
                    if [[ "$exclusive_tests" == "" ]]; then
                        exclusive_tests="^$testcase$"
                    else
                        exclusive_tests="$exclusive_tests|^$testcase$"
                    fi
                elif [[ "$is_multicard" != "" ]]; then
                    if [[ "$multiple_card_tests" == "" ]]; then
                        multiple_card_tests="^$testcase$"
                    else
                        multiple_card_tests="$multiple_card_tests|^$testcase$"
                    fi
                else
1085
                    if [[ "${#single_card_tests}" -gt 10000 ]];then
1086 1087 1088 1089 1090 1091 1092 1093
                        if [[ "$single_card_tests_1" == "" ]]; then 
                            single_card_tests_1="^$testcase$"
                        else
                            single_card_tests_1="$single_card_tests_1|^$testcase$"
                        fi
                        continue
                    fi

1094 1095 1096 1097 1098 1099 1100 1101
                    if [[ "$single_card_tests" == "" ]]; then
                        single_card_tests="^$testcase$"
                    else
                        single_card_tests="$single_card_tests|^$testcase$"
                    fi
                fi
                is_exclusive=''
                is_multicard=''
1102
                is_nightly=''
1103 1104 1105 1106
                matchstr=''
                testcase=''
        done <<< "$test_cases";

1107
        card_test "$single_card_tests" 1    # run cases with single GPU
1108
        card_test "$single_card_tests_1" 1    # run cases with single GPU
1109 1110
        card_test "$multiple_card_tests" 2  # run cases with two GPUs
        card_test "$exclusive_tests"        # run cases exclusively, in this cases would be run with 4/8 GPUs
Z
zhangchunle 已提交
1111 1112
        collect_failed_tests
        rm -f $tmp_dir/*
1113 1114 1115 1116
        exec_times=0
        retry_unittests_record=''
        retry_time=3
        exec_time_array=('first' 'second' 'third')
1117
        exec_retry_threshold=20
1118
        if [ -n "$failed_test_lists" ];then
1119 1120 1121 1122 1123 1124
            read need_retry_ut_str <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(.+\)" | sed 's/(.\+)//' | sed 's/- //' )
            need_retry_ut_arr=(${need_retry_ut_str})
            need_retry_ut_count=${#need_retry_ut_arr[@]}
            if [ $need_retry_ut_count -lt $exec_retry_threshold ];then
                while ( [ $exec_times -lt $retry_time ] && [ -n "${failed_test_lists}" ] )
                    do
1125
                        
1126 1127 1128 1129 1130 1131 1132 1133 1134 1135 1136 1137 1138 1139 1140 1141 1142 1143 1144 1145 1146 1147 1148 1149 1150 1151 1152 1153 1154 1155
                        retry_unittests_record="$retry_unittests_record$failed_test_lists"
                        failed_test_lists_ult=`echo "${failed_test_lists}" |grep -Po '[^ ].*$'`
                        read retry_unittests <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(.+\)" | sed 's/(.\+)//' | sed 's/- //' )
                        echo "========================================="
                        echo "This is the ${exec_time_array[$exec_times]} time to re-run"
                        echo "========================================="
                        echo "The following unittest will be re-run:"
                        echo "${failed_test_lists_ult}"
                            
                        for line in ${retry_unittests[@]} ;
                            do

                                one_card_tests=$single_card_tests'|'$single_card_tests_1

                                read tmp_one_tmp <<< "$( echo $one_card_tests | grep -oEi $line )"
                                read tmp_mul_tmp <<< "$( echo $multiple_card_tests | grep -oEi $line )"
                                read exclusive_tmp <<< "$( echo $exclusive_tests | grep -oEi $line )"

                                if [[ "$tmp_one_tmp" != ""  ]]; then
                                    if [[ "$one_card_retry" == "" ]]; then
                                        one_card_retry="^$line$"
                                    else
                                        one_card_retry="$one_card_retry|^$line$"
                                    fi
                                elif [[ "$tmp_mul_tmp" != "" ]]; then
                                    if [[ "$multiple_card_retry" == "" ]]; then
                                        multiple_card_retry="^$line$"
                                    else
                                        multiple_card_retry="$multiple_card_retry|^$line$"
                                    fi
1156
                                else
1157 1158 1159 1160 1161
                                    if [[ "$exclusive_retry" == "" ]];then
                                        exclusive_retry="^$line$"
                                    else
                                        exclusive_retry="$exclusive_retry|^$line$"
                                    fi
1162 1163
                                fi

1164
                            done
1165

1166 1167 1168
                        if [[ "$one_card_retry" != "" ]]; then
                            card_test "$one_card_retry" 1
                        fi
1169

1170 1171 1172
                        if [[ "$multiple_card_retry" != "" ]]; then
                            card_test "$multiple_card_retry" 2
                        fi
1173

1174 1175 1176 1177 1178 1179 1180 1181 1182 1183 1184 1185 1186 1187 1188 1189 1190 1191
                        if [[ "$exclusive_retry" != "" ]]; then
                            card_test "$exclusive_retry"
                        fi
                        
                        exec_times=$[$exec_times+1]
                        failed_test_lists=''
                        collect_failed_tests
                        rm -f $tmp_dir/*
                        one_card_retry=''
                        multiple_card_retry=''
                        exclusive_retry=''
                        retry_unittests=''
                    done
            else 
                echo "========================================="
                echo "There are more than 20 failed unit tests, so no unit test retry!!!"
                echo "========================================="
            fi
1192 1193
        fi

1194
        if [[ "$EXIT_CODE" != "0" ]]; then
1195 1196 1197 1198 1199 1200 1201 1202 1203 1204 1205 1206 1207 1208 1209
            if [[ "$failed_test_lists" == "" ]]; then
                echo "========================================"
                echo "There are failed tests, which have been successful after re-run:"
                echo "========================================"
                echo "The following tests have been re-ran:"
                echo "${retry_unittests_record}"
            else
                failed_test_lists_ult=`echo "${failed_test_lists}" |grep -Po '[^ ].*$'`
                echo "========================================"
                echo "Summary Failed Tests... "
                echo "========================================"
                echo "The following tests FAILED: "
                echo "${failed_test_lists_ult}"
                exit 8;
            fi
1210 1211 1212 1213 1214
        fi
set -ex
    fi
}

T
tianshuo78520a 已提交
1215 1216 1217 1218 1219 1220 1221 1222 1223 1224 1225 1226 1227 1228 1229 1230 1231 1232 1233
function parallel_test_base_cpu() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit cpu tests ...
    ========================================
EOF
        ut_startTime_s=`date +%s`
        ctest --output-on-failure -j $1
        ut_endTime_s=`date +%s`
        echo "CPU testCase Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
        if [[ "$EXIT_CODE" != "0" ]]; then
            exit 8;
        fi
    fi
}

T
tianshuo78520a 已提交
1234 1235 1236 1237 1238 1239 1240 1241 1242 1243 1244 1245 1246
function parallel_test_base_xpu() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit cpu tests ...
    ========================================
EOF

set +x
        ut_startTime_s=`date +%s`
        test_cases=$(ctest -N -V | grep "_xpu" )        # cases list which would be run exclusively
T
tianshuo78520a 已提交
1247
        get_quickly_disable_ut||disable_ut_quickly=''   # indicate whether the case was in quickly disable list
T
tianshuo78520a 已提交
1248 1249 1250 1251 1252 1253 1254 1255 1256 1257 1258 1259 1260 1261 1262 1263 1264 1265 1266 1267 1268 1269
        while read -r line; do
            if [[ "$line" == "" ]]; then
                continue
            fi
            read testcase <<< $(echo "$line"|grep -oEi "\w+$")
            if [[ "$single_card_tests" == "" ]]; then
                single_card_tests="^$testcase$"
            else
                single_card_tests="$single_card_tests|^$testcase$"
            fi
        done <<< "$test_cases";
        card_test "$single_card_tests" 1
        collect_failed_tests
set -x
        ut_endTime_s=`date +%s`
        echo "XPU testCase Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
        if [[ "$EXIT_CODE" != "0" ]]; then
            exit 8;
        fi
    fi   
}

1270
function parallel_test() {
Z
zhangchunle 已提交
1271
    ut_total_startTime_s=`date +%s`
1272 1273
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
1274
    pip install ${PADDLE_ROOT}/build/python/dist/*whl
T
tianshuo78520a 已提交
1275 1276 1277
    if [ "$WITH_GPU" == "ON" ];then
        parallel_test_base_gpu
    else
T
tianshuo78520a 已提交
1278 1279 1280 1281 1282
        if [ "$WITH_XPU" == "ON" ];then
            parallel_test_base_xpu
        else
            parallel_test_base_cpu ${PROC_RUN:-1}
        fi
T
tianshuo78520a 已提交
1283
    fi
Z
zhangchunle 已提交
1284 1285
    ut_total_endTime_s=`date +%s`
    echo "TestCases Total Time: $[ $ut_total_endTime_s - $ut_total_startTime_s ]s"
1286 1287
}

1288 1289 1290 1291 1292 1293 1294
function enable_unused_var_check() {
    # NOTE(zhiqiu): Set FLAGS_enable_unused_var_check=1 here to enable unused_var_check,
    # which checks if an operator has unused input variable(s).
    # Currently, use it in coverage CI job.
    export FLAGS_enable_unused_var_check=1
}

1295 1296 1297 1298 1299 1300 1301 1302 1303 1304 1305 1306 1307 1308 1309 1310 1311 1312
function gen_doc_lib() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ========================================
    Building documentation library ...
    In /paddle/build
    ========================================
EOF
    cmake .. \
        -DCMAKE_BUILD_TYPE=Release \
        -DWITH_GPU=OFF \
        -DWITH_MKL=OFF \

    local LIB_TYPE=$1
    case $LIB_TYPE in
      full)
        # Build full Paddle Python module. Will timeout without caching 'copy_paddle_pybind' first
1313
        make -j `nproc` framework_py_proto copy_paddle_pybind paddle_python
1314 1315 1316 1317 1318 1319 1320 1321 1322 1323 1324 1325 1326
        ;;
      pybind)
        # Build paddle pybind library. Takes 49 minutes to build. Might timeout
        make -j `nproc` copy_paddle_pybind
        ;;
      proto)
        # Even smaller library.
        make -j `nproc` framework_py_proto
        ;;
      *)
        exit 0
        ;;
      esac
1327 1328 1329 1330 1331
}


function gen_dockerfile() {
    # Set BASE_IMAGE according to env variables
1332 1333
    CUDA_MAJOR="$(echo $CUDA_VERSION | cut -d '.' -f 1).$(echo $CUDA_VERSION | cut -d '.' -f 2)"
    CUDNN_MAJOR=$(echo $CUDNN_VERSION | cut -d '.' -f 1)
1334
    if [[ ${WITH_GPU} == "ON" ]]; then
1335
        BASE_IMAGE="nvidia/cuda:${CUDA_MAJOR}-cudnn${CUDNN_MAJOR}-devel-ubuntu16.04"
1336
    else
1337
        BASE_IMAGE="ubuntu:16.04"
1338 1339 1340 1341
    fi

    DOCKERFILE_GPU_ENV=""
    DOCKERFILE_CUDNN_DSO=""
X
Xi Chen 已提交
1342
    DOCKERFILE_CUBLAS_DSO=""
1343 1344
    if [[ ${WITH_GPU:-OFF} == 'ON' ]]; then
        DOCKERFILE_GPU_ENV="ENV LD_LIBRARY_PATH /usr/lib/x86_64-linux-gnu:\${LD_LIBRARY_PATH}"
X
Xi Chen 已提交
1345
        DOCKERFILE_CUDNN_DSO="RUN ln -sf /usr/lib/x86_64-linux-gnu/libcudnn.so.${CUDNN_MAJOR} /usr/lib/x86_64-linux-gnu/libcudnn.so"
X
Xi Chen 已提交
1346
        DOCKERFILE_CUBLAS_DSO="RUN ln -sf /usr/local/cuda/targets/x86_64-linux/lib/libcublas.so.${CUDA_MAJOR} /usr/lib/x86_64-linux-gnu/libcublas.so"
1347 1348 1349 1350
    fi

    cat <<EOF
    ========================================
1351
    Generate ${PADDLE_ROOT}/build/Dockerfile ...
1352 1353
    ========================================
EOF
1354 1355 1356 1357 1358 1359 1360 1361 1362 1363 1364 1365 1366 1367 1368
    
    ref_CUDA_MAJOR="$(echo $CUDA_VERSION | cut -d '.' -f 1)"
    if [[ ${WITH_GPU} == "ON"  ]]; then
        ref_gpu=gpu-cuda${ref_CUDA_MAJOR}-cudnn${CUDNN_MAJOR}
    else
        ref_gpu=cpu
    fi
    if [[ ${WITH_GPU} == "ON"  ]]; then
        install_gpu="_gpu"
    else
        install_gpu=""
    fi
    if [[ ${WITH_MKL} == "ON" ]]; then
        ref_mkl=mkl
    else
1369
        ref_mkl=openblas
1370
    fi
1371

1372 1373 1374 1375 1376 1377
    ref_web=https://paddle-wheel.bj.bcebos.com/${PADDLE_BRANCH}-${ref_gpu}-${ref_mkl}

    ref_paddle2=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp27-cp27mu-linux_x86_64.whl
    ref_paddle35=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp35-cp35m-linux_x86_64.whl
    ref_paddle36=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp36-cp36m-linux_x86_64.whl
    ref_paddle37=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1378
    ref_paddle38=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp38-cp38-linux_x86_64.whl
1379 1380 1381 1382 1383

    ref_paddle2_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp27-cp27mu-linux_x86_64.whl
    ref_paddle35_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp35-cp35m-linux_x86_64.whl
    ref_paddle36_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp36-cp36m-linux_x86_64.whl
    ref_paddle37_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1384
    ref_paddle38_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp38-cp38-linux_x86_64.whl
1385

1386
    if [[ ${PADDLE_BRANCH} != "0.0.0" && ${WITH_MKL} == "ON" && ${WITH_GPU} == "ON" ]]; then
1387 1388 1389 1390
        ref_paddle2=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp35-cp35m-linux_x86_64.whl
        ref_paddle36=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp36-cp36m-linux_x86_64.whl
        ref_paddle37=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1391
        ref_paddle38=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp38-cp38-linux_x86_64.whl
1392 1393 1394 1395
        ref_paddle2_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp35-cp35m-linux_x86_64.whl
        ref_paddle36_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp36-cp36m-linux_x86_64.whl
        ref_paddle37_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1396
        ref_paddle38_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp38-cp38-linux_x86_64.whl
1397 1398 1399 1400 1401 1402 1403 1404 1405 1406
    fi

    #ref_paddle2_mv1=""
    #ref_paddle2_mv2=""
    ref_paddle35_mv1=""
    ref_paddle35_mv2=""
    ref_paddle36_mv1=""
    ref_paddle36_mv2=""
    #ref_paddle37_mv1=""
    #ref_paddle37_mv2=""
1407
    if [[ ${PADDLE_BRANCH} == "0.0.0" && ${WITH_GPU} == "ON" ]]; then
1408 1409 1410 1411 1412 1413 1414 1415 1416 1417 1418 1419 1420
        #ref_paddle2_whl=paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35_whl=paddlepaddle_gpu-1.5.1-cp35-cp35m-linux_x86_64.whl
        ref_paddle36_whl=paddlepaddle_gpu-1.5.1-cp36-cp36m-linux_x86_64.whl
        #ref_paddle37_whl=paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl
        #ref_paddle2_mv1="mv ref_paddle2 paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl &&"
        #ref_paddle2_mv2="&& mv paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl ref_paddle2"
        ref_paddle35_mv1="mv ${ref_paddle35} ${ref_paddle35_whl} &&"
        ref_paddle35_mv2="&& mv ${ref_paddle35_whl} ${ref_paddle35}"
        ref_paddle36_mv1="mv ${ref_paddle36} ${ref_paddle36_whl} &&"
        ref_paddle36_mv2="&& mv ${ref_paddle36_whl} ${ref_paddle36}"
        #ref_paddle37_mv1="mv ref_paddle37 paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl &&"
        #ref_paddle37_mv2="&& mv paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl ref_paddle37"
    fi
1421
    if [[ ${PADDLE_BRANCH} == "0.0.0" && ${WITH_GPU} != "ON" ]]; then
1422 1423 1424 1425 1426 1427 1428 1429 1430 1431 1432 1433 1434 1435
        #ref_paddle2_whl=paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35_whl=paddlepaddle-1.5.1-cp35-cp35m-linux_x86_64.whl
        ref_paddle36_whl=paddlepaddle-1.5.1-cp36-cp36m-linux_x86_64.whl
        #ref_paddle37_whl=paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl
        #ref_paddle2_mv1="mv ref_paddle2 paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl &&"
        #ref_paddle2_mv2="&& mv paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl ref_paddle2"
        ref_paddle35_mv1="mv ${ref_paddle35} ${ref_paddle35_whl} &&"
        ref_paddle35_mv2="&& mv ${ref_paddle35_whl} ${ref_paddle35}"
        ref_paddle36_mv1="mv ${ref_paddle36} ${ref_paddle36_whl} &&"
        ref_paddle36_mv2="&& mv ${ref_paddle36_whl} ${ref_paddle36}"
        #ref_paddle37_mv1="mv ref_paddle37 paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl &&"
        #ref_paddle37_mv2="&& mv paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl ref_paddle37"
    fi
    
1436 1437 1438 1439 1440 1441 1442
    cat > ${PADDLE_ROOT}/build/Dockerfile <<EOF
    FROM ${BASE_IMAGE}
    MAINTAINER PaddlePaddle Authors <paddle-dev@baidu.com>
    ENV HOME /root
EOF

    if [[ ${WITH_GPU} == "ON"  ]]; then
1443
        NCCL_DEPS="apt-get install -y --allow-downgrades --allow-change-held-packages libnccl2=2.4.7-1+cuda${CUDA_MAJOR} libnccl-dev=2.4.7-1+cuda${CUDA_MAJOR} || true"
1444
    else
1445
        NCCL_DEPS="true"
1446 1447
    fi

1448 1449 1450 1451
    if [[ ${WITH_GPU} == "ON" && ${CUDA_MAJOR} = "8.0" ]]; then 
        NCCL_DEPS="apt-get install -y --allow-downgrades --allow-change-held-packages libnccl2=2.2.13-1+cuda8.0 libnccl-dev=2.2.13-1+cuda8.0"
    fi

T
Tao Luo 已提交
1452 1453
    PADDLE_VERSION="paddle version"
    CMD='"paddle", "version"'
1454 1455
    
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1456 1457 1458
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y wget python3 python3-pip libgtk2.0-dev dmidecode python3-tk && \
T
tianshuo78520a 已提交
1459
        pip3 install py-cpuinfo==5.0.0 && wget ${ref_web}/${ref_paddle35} && ${ref_paddle35_mv1} pip3 install ${ref_paddle35_whl} ${ref_paddle35_mv2}; apt-get install -f -y && \
1460
        apt-get clean -y && \
1461
        rm -f ${ref_paddle35} && \
1462 1463 1464 1465
        ldconfig
    ${DOCKERFILE_CUDNN_DSO}
    ${DOCKERFILE_CUBLAS_DSO}
    ${DOCKERFILE_GPU_ENV}
1466
EOF
1467
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1468 1469 1470 1471 1472 1473 1474
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN mkdir -p /root/python_build/ && wget -q https://www.sqlite.org/2018/sqlite-autoconf-3250300.tar.gz && \
        tar -zxf sqlite-autoconf-3250300.tar.gz && cd sqlite-autoconf-3250300 && \
T
Tao Luo 已提交
1475
        ./configure -prefix=/usr/local && make install -j8 && cd ../ && rm sqlite-autoconf-3250300.tar.gz && \
1476 1477 1478
        wget -q https://www.python.org/ftp/python/3.6.0/Python-3.6.0.tgz && \
        tar -xzf Python-3.6.0.tgz && cd Python-3.6.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
1479 1480
        make -j8 > /dev/null && make altinstall > /dev/null && cd ../ && rm Python-3.6.0.tgz
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && ldconfig && \
T
tianshuo78520a 已提交
1481
        wget ${ref_web}/${ref_paddle36} && ${ref_paddle36_mv1} pip3.6 install ${ref_paddle36_whl} ${ref_paddle36_mv2}; apt-get install -f -y && \
1482
        apt-get clean -y && \
1483
        rm -f ${ref_paddle36} && \
1484 1485
        ldconfig
EOF
1486
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1487 1488 1489 1490 1491 1492 1493 1494
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN wget -q https://www.python.org/ftp/python/3.7.0/Python-3.7.0.tgz && \
        tar -xzf Python-3.7.0.tgz && cd Python-3.7.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
1495 1496
        make -j8 > /dev/null && make altinstall > /dev/null && cd ../ && rm Python-3.7.0.tgz
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && ldconfig && \
T
tianshuo78520a 已提交
1497
        wget ${ref_web}/${ref_paddle37} && pip3.7 install ${ref_paddle37_whl}; apt-get install -f -y && \
1498
        apt-get clean -y && \
1499
        rm -f ${ref_paddle37} && \
1500
        ldconfig
G
guofei 已提交
1501 1502 1503 1504 1505 1506 1507 1508 1509 1510 1511 1512
EOF
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN wget -q https://www.python.org/ftp/python/3.8.0/Python-3.8.0.tgz && \
        tar -xzf Python-3.8.0.tgz && cd Python-3.8.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
        make -j8 > /dev/null && make altinstall > /dev/null && cd ../ && rm Python-3.8.0.tgz
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && ldconfig && \
T
tianshuo78520a 已提交
1513
        wget ${ref_web}/${ref_paddle38} && pip3.8 install ${ref_paddle38_whl}; apt-get install -f -y && \
G
guofei 已提交
1514 1515 1516
        apt-get clean -y && \
        rm -f ${ref_paddle38} && \
        ldconfig
1517
EOF
1518
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1519
    # run paddle version to install python packages first
1520 1521
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y wget python-pip python-opencv libgtk2.0-dev dmidecode python-tk && easy_install -U pip && \
1522
        wget ${ref_web}/${ref_paddle2} && pip install ${ref_paddle2_whl}; apt-get install -f -y && \
1523
        apt-get clean -y && \
1524
        rm -f ${ref_paddle2} && \
1525 1526
        ${PADDLE_VERSION} && \
        ldconfig
1527
EOF
1528

1529
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1530 1531 1532 1533 1534
    # default command shows the paddle version and exit
    CMD [${CMD}]
EOF
}

1535
function gen_fluid_lib() {
L
Lei Wang 已提交
1536 1537
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
T
Tao Luo 已提交
1538
    cat <<EOF
1539
    ========================================
1540
    Generating fluid library for train and inference ...
1541 1542
    ========================================
EOF
1543 1544 1545 1546
    parallel_number=`nproc`
    if [[ "$1" != "" ]]; then
      parallel_number=$1
    fi
Z
zhangchunle 已提交
1547 1548 1549 1550 1551 1552 1553 1554
    startTime_s=`date +%s`
    set +e
    cmake .. -DWITH_DISTRIBUTE=OFF -DON_INFER=ON -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-Auto};build_error=$?
    make -j ${parallel_number} fluid_lib_dist;build_error=$?
    make -j ${parallel_number} inference_lib_dist;build_error=$?
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
Z
zhangchunle 已提交
1555 1556
    endTime_s=`date +%s`
    echo "Build Time: $[ $endTime_s - $startTime_s ]s"
1557
    build_size "paddle_inference"
T
Tao Luo 已提交
1558 1559
}

1560
function tar_fluid_lib() {
T
Tao Luo 已提交
1561
    cat <<EOF
T
Tao Luo 已提交
1562
    ========================================
1563
    Taring fluid library for train and inference ...
T
Tao Luo 已提交
1564 1565
    ========================================
EOF
T
Tao Luo 已提交
1566
    cd ${PADDLE_ROOT}/build
1567
    cp -r paddle_install_dir fluid
T
Tao Luo 已提交
1568
    tar -czf fluid.tgz fluid
1569 1570
    cp -r paddle_inference_install_dir paddle_inference
    tar -czf paddle_inference.tgz paddle_inference
1571 1572
}

1573
function test_fluid_lib() {
T
Tao Luo 已提交
1574
    cat <<EOF
1575
    ========================================
1576
    Testing fluid library for inference ...
1577 1578
    ========================================
EOF
Z
zhangchunle 已提交
1579
    fluid_startTime_s=`date +%s`
T
Tao Luo 已提交
1580 1581 1582 1583
    cd ${PADDLE_ROOT}/paddle/fluid/inference/api/demo_ci
    ./run.sh ${PADDLE_ROOT} ${WITH_MKL:-ON} ${WITH_GPU:-OFF} ${INFERENCE_DEMO_INSTALL_DIR} \
             ${TENSORRT_INCLUDE_DIR:-/usr/local/TensorRT/include} \
             ${TENSORRT_LIB_DIR:-/usr/local/TensorRT/lib}
T
tianshuo78520a 已提交
1584
    EXIT_CODE=$?
Z
zhangchunle 已提交
1585 1586
    fluid_endTime_s=`date +%s`
    echo "test_fluid_lib Total Time: $[ $fluid_endTime_s - $fluid_startTime_s ]s"          
T
Tao Luo 已提交
1587
    ./clean.sh
T
tianshuo78520a 已提交
1588 1589 1590
    if [[ "$EXIT_CODE" != "0" ]]; then
        exit 8;
    fi
1591 1592
}

1593 1594 1595 1596 1597 1598
function test_fluid_lib_train() {
    cat <<EOF
    ========================================
    Testing fluid library for training ...
    ========================================
EOF
Z
zhangchunle 已提交
1599
    fluid_train_startTime_s=`date +%s`
1600 1601
    cd ${PADDLE_ROOT}/paddle/fluid/train/demo
    ./run.sh ${PADDLE_ROOT} ${WITH_MKL:-ON}
T
tianshuo78520a 已提交
1602
    EXIT_CODE=$?
Z
zhangchunle 已提交
1603 1604
    fluid_train_endTime_s=`date +%s`
    echo "test_fluid_lib_train Total Time: $[ $fluid_train_endTime_s - $fluid_train_startTime_s ]s"
1605
    ./clean.sh
T
tianshuo78520a 已提交
1606 1607 1608
    if [[ "$EXIT_CODE" != "0" ]]; then
        exit 8;
    fi
1609
}
T
tianshuo78520a 已提交
1610

T
tianshuo78520a 已提交
1611

T
tianshuo78520a 已提交
1612 1613 1614 1615 1616
function build_document_preview() {
    sh /paddle/tools/document_preview.sh ${PORT}
}


T
tianshuo78520a 已提交
1617
function example() {
Z
Zeng Jinle 已提交
1618
    pip install ${PADDLE_ROOT}/build/python/dist/*.whl
T
tianshuo78520a 已提交
1619
    paddle version
1620
    cd ${PADDLE_ROOT}/tools
Z
zhangchunle 已提交
1621 1622
    python sampcd_processor.py cpu;example_error=$?
    if [ "$example_error" != "0" ];then
1623
      echo "Code instance execution failed" >&2
Z
zhangchunle 已提交
1624
      exit 5
T
tianshuo78520a 已提交
1625 1626 1627
    fi
}

1628 1629 1630 1631
function test_op_benchmark() {
    bash ${PADDLE_ROOT}/tools/test_op_benchmark.sh
}

1632 1633 1634 1635
function summary_check_problems() {
    set +x
    local check_style_code=$1
    local example_code=$2
1636 1637
    local check_style_info=$3
    local example_info=$4
1638 1639 1640
    if [ $check_style_code -ne 0 -o $example_code -ne 0 ];then
      echo "========================================"
      echo "summary problems:"
1641 1642 1643 1644 1645 1646
      if [ $check_style_code -ne 0 -a $example_code -ne 0 ];then
        echo "There are 2 errors: Code format error and Example code error."
      else
        [ $check_style_code -ne 0 ] && echo "There is 1 error: Code format error."
        [ $example_code -ne 0 ] && echo "There is 1 error: Example code error."
      fi
1647 1648
      echo "========================================"
      if [ $check_style_code -ne 0 ];then
1649 1650
        echo "*****Code format error***** Please fix it according to the diff information:"
        echo "$check_style_info" | grep "code format error" -A $(echo "$check_style_info" | wc -l)
1651 1652
      fi
      if [ $example_code -ne 0 ];then
1653 1654
        echo "*****Example code error***** Please fix the error listed in the information:"
        echo "$example_info" | grep "API check -- Example Code" -A $(echo "$example_info" | wc -l)
1655 1656 1657 1658 1659 1660 1661
      fi
      [ $check_style_code -ne 0 ] && exit $check_style_code
      [ $example_code -ne 0 ] && exit $example_code
    fi
    set -x
}

1662
function main() {
Z
Zeng Jinle 已提交
1663
    local CMD=$1 
1664
    local parallel_number=$2
1665
    init
I
iducn 已提交
1666 1667
    if [ "$CMD" != "assert_file_approvals" ];then
      python ${PADDLE_ROOT}/tools/summary_env.py
I
iducn 已提交
1668
      bash ${PADDLE_ROOT}/tools/get_cpu_info.sh
I
iducn 已提交
1669
    fi
1670
    case $CMD in
1671
      build_only)
Z
zhangchunle 已提交
1672
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1673 1674
        ;;
      build_and_check)
1675
        set +e
1676
        check_style_info=$(check_style)
1677
        check_style_code=$?
Z
Zeng Jinle 已提交
1678
        generate_upstream_develop_api_spec ${PYTHON_ABI:-""} ${parallel_number}
Z
zhangchunle 已提交
1679
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1680 1681
        check_sequence_op_unittest
        generate_api_spec ${PYTHON_ABI:-""} "PR"
1682 1683
        set +e
        example_info=$(example)
1684
        example_code=$?
1685
        summary_check_problems $check_style_code $example_code "$check_style_info" "$example_info"
T
tianshuo78520a 已提交
1686
        assert_api_spec_approvals
1687
        ;;
1688 1689
      build)
        cmake_gen ${PYTHON_ABI:-""}
1690
        build ${parallel_number}
1691
        gen_dockerfile ${PYTHON_ABI:-""}
1692
        assert_api_spec_approvals
1693
        ;;
1694 1695
      combine_avx_noavx)
        combine_avx_noavx_build
1696
        gen_dockerfile ${PYTHON_ABI:-""}
1697 1698 1699
        ;;
      combine_avx_noavx_build_and_test)
        combine_avx_noavx_build
1700
        gen_dockerfile ${PYTHON_ABI:-""}
1701 1702
        parallel_test_base
        ;;
1703
      test)
1704
        parallel_test
1705
        ;;
1706 1707 1708
      single_test)
        single_test $2
        ;;
1709 1710 1711
      bind_test)
        bind_test
        ;;
1712 1713 1714
      gen_doc_lib)
        gen_doc_lib $2
        ;;
1715
      dockerfile)
1716
        gen_dockerfile ${PYTHON_ABI:-""}
1717 1718 1719
        ;;
      fluid_inference_lib)
        cmake_gen ${PYTHON_ABI:-""}
1720
        gen_fluid_lib ${parallel_number}
1721 1722
        tar_fluid_lib
        test_fluid_lib
1723
        ;;
1724 1725 1726 1727
      build_inference_lib)
        cmake_gen ${PYTHON_ABI:-""}
        gen_fluid_lib ${parallel_number}
        ;;
1728 1729 1730
      check_style)
        check_style
        ;;
L
Lei Wang 已提交
1731
      cicheck)
1732 1733 1734 1735 1736 1737
        cmake_gen ${PYTHON_ABI:-""}
        build ${parallel_number}
        enable_unused_var_check
        parallel_test
        ;;
      cicheck_coverage)
1738
        check_approvals_of_unittest 1
1739
        check_diff_file_for_coverage
Z
zhangchunle 已提交
1740
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1741
        enable_unused_var_check
1742
        parallel_test
L
Liu Xudong 已提交
1743
        check_coverage
1744
        check_change_of_unittest ${PYTHON_ABI:-""}
L
Lei Wang 已提交
1745
        ;;
G
gongweibao 已提交
1746 1747
      cicheck_brpc)
        cmake_gen ${PYTHON_ABI:-""}
1748
        build ${parallel_number}
G
gongweibao 已提交
1749 1750
        run_brpc_test
        ;;
1751
      assert_api)
Z
Zeng Jinle 已提交
1752
        generate_upstream_develop_api_spec ${PYTHON_ABI:-""} ${parallel_number}
Y
Yu Yang 已提交
1753
        assert_api_spec_approvals
1754 1755
        ;;
      test_inference)
1756
        gen_fluid_lib ${parallel_number}
1757
        test_fluid_lib
T
tianshuo78520a 已提交
1758
        #test_fluid_lib_train
1759 1760 1761 1762
        ;;
      test_train)
        gen_fluid_lib ${parallel_number}
        test_fluid_lib_train
1763 1764 1765 1766
        ;;
      assert_api_approvals)
        assert_api_spec_approvals
        ;;
Z
zhangchunle 已提交
1767 1768 1769
      assert_file_approvals)
        assert_file_diff_approvals
        ;; 
1770
      maccheck)
Z
zhangchunle 已提交
1771
        cmake_gen_and_build_mac ${PYTHON_ABI:-""}
L
lujun 已提交
1772
        run_mac_test ${PYTHON_ABI:-""} ${PROC_RUN:-1}
1773
        ;;
1774
      maccheck_py35)
Z
zhangchunle 已提交
1775
        cmake_gen_and_build_mac ${PYTHON_ABI:-""}
1776
        run_mac_test ${PYTHON_ABI:-""} ${PROC_RUN:-1}
1777
        check_change_of_unittest ${PYTHON_ABI:-""}
1778
        ;;
J
JiabinYang 已提交
1779 1780 1781 1782
      macbuild)
        cmake_gen ${PYTHON_ABI:-""}
        build_mac
        ;;
M
minqiyang 已提交
1783
      cicheck_py35)
Z
zhangchunle 已提交
1784
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1785
        parallel_test
M
minqiyang 已提交
1786
        ;;
T
tianshuo78520a 已提交
1787 1788 1789 1790
      check_xpu)
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
        parallel_test
        ;;
Y
Yu Yang 已提交
1791 1792 1793
      cmake_gen)
        cmake_gen ${PYTHON_ABI:-""}
        ;;
C
chalsliu 已提交
1794 1795 1796
      cmake_gen_in_current_dir)
        cmake_gen_in_current_dir ${PYTHON_ABI:-""}
        ;;
Y
Yu Yang 已提交
1797
      gen_fluid_lib)
1798
        gen_fluid_lib ${parallel_number}
Y
Yu Yang 已提交
1799 1800 1801 1802
        ;;
      test_fluid_lib)
        test_fluid_lib
        ;;
T
tianshuo78520a 已提交
1803 1804 1805 1806 1807
      document)
        cmake_gen ${PYTHON_ABI:-""}
        build ${parallel_number}
        build_document_preview
        ;;
T
tianshuo78520a 已提交
1808 1809 1810
      api_example)
        example
        ;;
1811 1812 1813
      test_op_benchmark)
        test_op_benchmark
        ;;
1814 1815
      *)
        print_usage
1816
        exit 1
1817 1818
        ;;
      esac
1819
      echo "paddle_build script finished as expected"
1820 1821 1822
}

main $@